<!-- 会员机构管理-子机构管理-会员子机构管理 -->
<template>
    <app-view>
        <template #header>
            <app-filter :option="filterOption" />
        </template>
        <app-table :data="dataList" :columns="tableColumns" :loading="loading">
            <template #headerLeft>
                <app-operation :data-list="getActionButtons(['member_subinstitution_user_add'])"
                    @click="openComponent" />
            </template>
            <!-- 操作 -->
            <template #operate="{ row }">
                <app-operation size="small" :data-list="handleOperateButtons(row)"
                    @click="(code: string) => openComponent(code, row)" circle />
            </template>
            <template #footer>
                <app-pagination :total="total" v-model:page-size="pageSize" v-model:page-index="pageIndex"
                    @change="onSearch" />
            </template>
        </app-table>
        <component :is="componentMap.get(componentId)" v-bind="{ record }" @closed="closeComponent"
            v-if="componentId" />
    </app-view>
</template>

<script lang="ts" setup>
import { shallowRef } from 'vue'
import { ElMessage } from 'element-plus'
import { formatDate } from '@/filters'
import { getUserInfoTypeName } from '@/constants/member'
import { useEnum } from '@/hooks/enum'
import { useMarket } from '@/hooks/market'
import { useRequest } from '@/hooks/request'
import { useDataFilter } from '@/hooks/datatable-v2'
import { useOperation } from '@/hooks/operation'
import { queryOrganSon } from '@/services/api/member'
import AppTable from '@pc/components/base/table/index.vue'
import AppFilter from '@pc/components/base/table-filter-v2/index.vue'
import AppPagination from '@pc/components/base/pagination/index.vue'
import AppOperation from '@pc/components/base/operation/index.vue'
import { i18n } from '@/stores'

const { global: { t } } = i18n

// 机构状态
const areastatusEnum = useEnum('areastatus')
// 机构类型
const usertype2Enum = useEnum('usertype2')

const { getMarketOptions } = useMarket()

const { componentMap, componentId, record, openComponent, closeComponent, getActionButtons } = useOperation<Model.OrganSonRsp>({
    onClose: () => onSearch()
})

const { dataList, total, pageSize, pageIndex, loading, run } = useRequest(queryOrganSon, {
    params: {
        pageNum: 1,
        pageSize: 20
    },
    onError: (err) => {
        ElMessage.error(err)
    }
})

const tableColumns = shallowRef<Model.TableColumn[]>([
    { field: 'userid', label: '机构代码' },
    { field: 'accountname', label: '机构名称' },
    { field: 'parentname', label: '所属机构' },
    { field: 'memberusername', label: '所属会员' },
    { field: 'accountstatus', label: '机构状态', formatValue: (val) => areastatusEnum.getEnumTypeName(val) },
    { field: 'usertype', label: '机构类型', formatValue: (val) => usertype2Enum.getEnumTypeName(val) },
    { field: 'userinfotype', label: '所有者类型', formatValue: (val) => getUserInfoTypeName(val) },
    { field: 'userName', label: '操作员' },
    { field: 'modifytime', label: '最后更新时间', formatValue: (val) => formatDate(val) },
    { field: 'operate', label: 'common.operate', width: 200, fixed: 'right' }
])

const { filterOption, getQueryParams, resetFilters } = useDataFilter<Model.OrganSonReq>({
    filters: [
        {
            field: 'accountname',
            label: '机构'
        },
        {
            field: 'markets',
            label: '市场权限',
            options: () => getMarketOptions()
        },
        {
            field: 'accountstatus',
            label: '机构状态',
            options: () => areastatusEnum.getEnumOptions()
        },
    ],
    buttons: [
        { label: t('operation.search'), className: 'el-button--primary', onClick: () => onSearch() },
        { label: t('operation.reset'), className: 'el-button--primary', validateEvent: false, onClick: () => resetFilters() }
    ]
})

// 处理操作按钮
const handleOperateButtons = (row: Model.OrganSonRsp) => {
    const buttons = ['member_subinstitution_user_details', 'member_subinstitution_user_account', 'member_subinstitution_user_login']

    switch (row.modifystatus) {
        case 0:
        case 1:
            if (row.accountstatus === 6) {
                buttons.push('member_subinstitution_user_recover')
            } else {
                buttons.push('member_subinstitution_user_modify')
                if (![2, 3].includes(row.accountstatus)) {
                    buttons.push('member_subinstitution_user_close')
                }
            }
            break
        case 3:
        case 4:
            buttons.push('member_subinstitution_user_cancel')
            break
        default:
            buttons.push('member_subinstitution_user_modify')
    }

    return getActionButtons(buttons)
}

const onSearch = (clear = false) => {
    const qs = getQueryParams(clear)
    run(qs)
}
</script>